diff --git a/src/vhdlcode.l b/src/vhdlcode.l
index 3e027d7..c60a949 100644
--- a/src/vhdlcode.l
+++ b/src/vhdlcode.l
@@ -46,7 +46,8 @@
 #include "classdef.h"
 #include "filedef.h"
 #include "tooltip.h"
-
+#include "vhdlstring.h"
+#include "JavaCC.h"
 #define YY_NO_INPUT 1
 #define YY_NO_UNISTD_H 1
 
@@ -274,6 +276,7 @@ static void writeWord(const char *word,const char* curr_class=0,bool classLink=F
   for (unsigned int j=0;j<ttt.length();j++)
   {
     char c=ttt.at(j);
+    if(c<0) continue;
     if (c==' '|| c==',' || c==';' || c==':' || c=='(' || c==')' || c=='\r' || c=='\t' || c=='.')
     {
       if (found)
@@ -364,7 +368,8 @@ static void codifyLines(const char *text,const char *cl=0,bool classlink=FALSE,b
      if (c=='\n')
     {
       g_yyLineNr++;
-      QCString line = sp;
+      QString v(sp);
+      QCString line = v.utf8();
       line = line.left((int)(p-sp)-1);
       //*(p-1)='\0';
       //g_code->codify(sp);
@@ -783,8 +788,10 @@ GENERIC       {B}*("generic"){BN}*("(")
 
 BRACEOPEN     [(]{1}
 BRACECLOSE    [)]{1}
-
+CC            "*/"
 TEXTT         {B}*"--"[^\n]*
+CPP           ("/*!")[^*]*("*/")
+
 
 MAPCOMPONENT1 ({ALLTYPESMAP}[:]{ALLTYPESMAP}{TEXTT}*{BN}+("port"|"generic"){BN}+("map"){BN}*("("){1})
 MAPCOMPONENT2 {BN}*("port"|"generic"){BN}+("map"){BN}*("("){1}
@@ -1460,7 +1467,15 @@ XILINX      "INST"|"NET"|"PIN"|"BLKNM"|"BUFG"|"COLLAPSE"|"CPLD"|"COMPGRP"|"CONFI
                          }
 
 <*>.                     {
-                           g_code->codify(vhdlcodeYYtext);
+                          QCString text(vhdlcodeYYtext);
+
+			              codifyLines(text,0,FALSE,TRUE);
+                           }
+
+<*>{CPP}   {
+ QCString text(vhdlcodeYYtext);
+ fprintf(stderr,"\n  {{ %s }}",text.data());
+			   codifyLines(text,0,FALSE,TRUE);
     }
 
 <*>\n{TEXTT}          { // found normal or special comment on its own line
@@ -1506,16 +1521,37 @@ void resetVhdlCodeParserState()
   g_vhdlKeyDict.clear();
 }
 
-void parseVhdlCode(CodeOutputInterface &od,const char *className,const QCString &s, 
+void parseVhdlCode(CodeOutputInterface &od,const char *className,const QCString &sin,
                   bool exBlock, const char *exName,FileDef *fd,
                   int startLine,int endLine,bool inlineFragment,
                   MemberDef *memberDef,bool,Definition *searchCtx,
                   bool /* collectXRefs */)
 {
   //printf("***parseCode() exBlock=%d exName=%s fd=%p\n",exBlock,exName,fd);
-  if (s.isEmpty()) return;
+  if (sin.isEmpty()) return;
   printlex(yy_flex_debug, TRUE, __FILE__, fd ? fd->fileName().data(): NULL);
   TooltipManager::instance()->clearTooltips();
+
+   setlocale(LC_ALL,"en_US.UTF-8");
+  JAVACC_STRING_TYPE s = sin.data();
+  int fsize=sin.length();
+  // remove idle \0 chars
+
+int count=0;
+  for(int p=0;p<fsize;p++)
+  {
+
+      if(s[p]==L'\0'){
+      s[p]=L' ';
+      //if(s[p]<0)
+        //s[p]=0;
+      count++;
+      }
+
+  }
+
+
+
   if (memberDef)
   {
     ClassDef *dd=memberDef->getClassDef();
@@ -1524,7 +1560,7 @@ void parseVhdlCode(CodeOutputInterface &od,const char *className,const QCString
   }
   resetVhdlCodeParserState();
   g_code = &od;
-  g_inputString   = s;
+  g_inputString   = s.data();
   g_inputPosition = 0;
   g_currentFontClass = 0;
   g_needsTermination = FALSE;
diff --git a/src/vhdldocgen.cpp b/src/vhdldocgen.cpp
index d09de09..424db3f 100644
--- a/src/vhdldocgen.cpp
+++ b/src/vhdldocgen.cpp
@@ -1445,6 +1445,7 @@ void VhdlDocGen::formatString(const QCString &s, OutputList& ol,const MemberDef*
   for (int j=0;j<len;j++)
   {
     char c=qcs[j];
+//    if(c<0) continue;
     char b=c;
     if (j>0) b=qcs[j-1];
     if (c=='"' || c==',' || c=='\''|| c=='(' || c==')'  || c==':' || c=='[' || c==']' ) // || (c==':' && b!='=')) // || (c=='=' && b!='>'))
diff --git a/src/vhdljjparser.cpp b/src/vhdljjparser.cpp
old mode 100644
new mode 100755
index fdba5e2..114cc4a
--- a/src/vhdljjparser.cpp
+++ b/src/vhdljjparser.cpp
@@ -58,12 +58,12 @@ Entry*   VhdlParser::lastEntity=0  ;
 Entry*   VhdlParser::lastCompound=0  ;
 Entry*   VhdlParser::current=0;
 Entry*   VhdlParser::current_root  = 0;
-QCString VhdlParser::compSpec;
-QCString VhdlParser::currName;
-QCString VhdlParser::confName;
-QCString VhdlParser::genLabels;
-QCString VhdlParser::lab;
-QCString VhdlParser::forL;
+VhdlString VhdlParser::compSpec;
+VhdlString VhdlParser::currName;
+VhdlString VhdlParser::confName;
+VhdlString VhdlParser::genLabels;
+VhdlString VhdlParser::lab;
+VhdlString VhdlParser::forL;
 
 int VhdlParser::param_sec = 0;
 int VhdlParser::parse_sec=0;
@@ -84,7 +84,7 @@ static bool doxComment=FALSE; // doxygen comment ?
 static QCString strComment;
 static int iCodeLen;
 
-bool  checkMultiComment(QCString& qcs,int line);
+bool  checkMultiComment(const char* str,int line);
 QList<Entry>* getEntryAtLine(const Entry* ce,int line);
 
 //-------------------------------------
@@ -417,18 +417,18 @@ void VhdlParser::addCompInst(const char *n, const char* instName, const char* co
   current->startLine=iLine;
   current->bodyLine=iLine;
   current->type=instName;                       // foo:instname e.g proto or work. proto(ttt)
-  current->exception=genLabels.lower();         // |arch|label1:label2...
+  current->exception=genLabels.lower().data();         // |arch|label1:label2...
   current->name=n;                              // foo
   if (lastCompound)
   {
     current->args=lastCompound->name;             // architecture name
   }
   current->includeName=comp;                    // component/enity/configuration
-  int u=genLabels.find("|",1);
+  int u=genLabels.find("|");
   if (u>0)
   {
-    current->write=genLabels.right(genLabels.length()-u);
-    current->read=genLabels.left(u);
+	  current->write=genLabels.right(genLabels.length()-u).data();
+    current->read=genLabels.left(u).data();
   }
   //printf  (" \n genlable: [%s]  inst: [%s]  name: [%s] %d\n",n,instName,comp,iLine);
 
@@ -548,15 +548,15 @@ bool VhdlParser::isFuncProcProced()
   return FALSE;
 }
 
-void VhdlParser::pushLabel( QCString &label,QCString & val)
+void VhdlParser::pushLabel( VhdlString &label,VhdlString & val)
 {
   label+="|";
   label+=val;
 }
 
- QCString  VhdlParser::popLabel(QCString & q)
+ VhdlString  VhdlParser::popLabel(VhdlString & q)
 {
-  int i=q.findRev("|");
+  int i=q.findRev(L'|');
   if (i<0) return "";
   q = q.left(i);
   return q;
@@ -565,7 +565,7 @@ void VhdlParser::pushLabel( QCString &label,QCString & val)
 void VhdlParser::addConfigureNode(const char* a,const char*b, bool,bool isLeaf,bool inlineConf)
 {
   VhdlConfNode* co=0;
-  QCString ent;
+  VhdlString ent;
   ent=a;
 
   if (b)
@@ -675,7 +675,7 @@ void VhdlParser::mapLibPackage( Entry* root)
   Entry *rt;
   for (;(rt=eli.current());++eli)
   {
-    if (addLibUseClause(rt->name))
+    if (addLibUseClause(rt->name.data()))
     {
       Entry *current;
       EntryListIterator eLib(*root->children());
@@ -700,7 +700,7 @@ void VhdlParser::mapLibPackage( Entry* root)
   }// for
 }//MapLib
 
-bool VhdlParser::addLibUseClause(const QCString &type)
+bool VhdlParser::addLibUseClause(const VhdlString &type)
 {
   static bool showIEEESTD=Config_getBool(FORCE_LOCAL_INCLUDES);
 
@@ -785,7 +785,7 @@ void VhdlParser::setMultCommentLine()
   iDocLine=yyLineNr;
 }
 
-void VhdlParser::oneLineComment(QCString qcs)
+void VhdlParser::oneLineComment(VhdlString qcs)
 {
   bool isEndCode=qcs.contains("\\endcode");
 
@@ -798,7 +798,7 @@ void VhdlParser::oneLineComment(QCString qcs)
   else if (index > 0)
   {
     // assert(false);
-    strComment=qcs;
+    strComment=qcs.data();
     startCodeBlock(index);
     strComment.resize(0);
   }
@@ -807,16 +807,17 @@ void VhdlParser::oneLineComment(QCString qcs)
   {
     int j=qcs.find("--!");
     qcs=qcs.right(qcs.length()-3-j);
-    if (!checkMultiComment(qcs,iDocLine))
+    if (!checkMultiComment(qcs.data(),iDocLine))
     {
-      handleCommentBlock(qcs,TRUE);
+      handleCommentBlock(qcs.data(),TRUE);
     }
   }
 }
 
 
-bool  checkMultiComment(QCString& qcs,int line)
+bool  checkMultiComment(const char* str,int line)
 {
+  QCString qcs(str);
 	QList<Entry> *pTemp=getEntryAtLine(VhdlParser::current_root,line);
 
   if (pTemp->isEmpty()) return false;
diff --git a/vhdlparser/JavaCC.h b/vhdlparser/JavaCC.h
index 224b2b5..b310585 100644
--- a/vhdlparser/JavaCC.h
+++ b/vhdlparser/JavaCC.h
@@ -9,7 +9,7 @@
 #include "vhdlstring.h"
 
 #ifndef JAVACC_CHAR_TYPE
-#define JAVACC_CHAR_TYPE char
+#define JAVACC_CHAR_TYPE wchar_t
 #endif
 
 #ifndef JAVACC_STRING_TYPE
